[TODO] LeetCode #300: Longest Increasing Subsequence

来源:互联网 发布:mac修容粉香港价格 编辑:程序博客网 时间:2024/05/16 07:35

Problem Statement

(Source) Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(nlogn) time complexity?

Solution 1

class Solution(object):    def lengthOfLIS(self, nums):        """        :type nums: List[int]        :rtype: int        """        if not nums:            return 0        # dp:        ans = 1        dp = [1 for i in range(len(nums))]        for i in range(1, len(nums)):            for j in range(i):                if nums[j] < nums[i]: # euqal?                    dp[i] = max(dp[i], dp[j] + 1)            ans = max(ans, dp[i])        return ans

Complexity analysis
- Time complexity: O(n2), where n is the size of input array.
- Space complexity: O(n), where n is the size of input array.

Solution 2

[TODO!] O(nlogn).

0 0